#include "stdafx.h"
#include <stdlib.h>
#include <string.h>

#include "seznam.h"

item *mensi(listDescr *list, char *txt)
{
	item *pom, *x;
	for (pom = list->first, x = NULL;
		(pom != NULL) && (strcmp(txt, pom->word)>0);
		pom = pom->next)
			x = pom;

	return x;

}

bool listSortAdd(listDescr *list, char *txt)
{
	item *temp, *pos;
	for (temp = list->first; temp; temp = temp->next)
	{
		if (strcmp(txt, temp->word) == 0)
		{
			temp->count++;
			return true;
		}
	}
	temp = (item *)malloc(sizeof(item));
	if (temp == NULL)
	{
		return false;
	}
	temp->word = (char *)malloc((strlen(txt) + 1)*sizeof(char));
	if (temp->word == NULL)
	{
		free(temp);
		return false;
	}
	strcpy(temp->word, txt);
	temp->count = 1;
	pos = mensi(list, txt);
	if (pos == NULL)                    
	{
		temp->next = list->first;   // vkladani na zacatek
		list->first = temp;
	}
	else
	{
		temp->next = pos->next;		// vkladani doprostred nebo na konec
		pos->next = temp;
	}
	return true;

}

bool listAdd(listDescr *list, char *txt)
{
	item *temp;
	for (temp = list->first; temp; temp = temp->next)
	{
		if (strcmp(txt, temp->word) == 0)
		{
			temp->count++;
			return true;
		}
	}
	temp = (item *)malloc(sizeof(item));
	if (temp == NULL)
	{
		return false;
	}
	temp->word = (char *)malloc((strlen(txt) + 1)*sizeof(char));
	if (temp->word == NULL)
	{
		free(temp);
		return false;
	}
	strcpy(temp->word, txt);
	temp->count = 1;
	temp->next = list->first;
	list->first = temp;
	return true;
}
void listShow(listDescr *list)
{
	item *temp;
	int poc = 0;
	if (list->first == NULL)
	{
		printf("Seznam je prazdny.\n");
		return;
	}
	printf("Seznam - adresa prvniho prvku: %p\n", list->first);
	for (temp = list->first; temp; temp = temp->next)
	{
		printf("%3d ADR: %p NEXT: %p COUNT: %3d WORD: %s\n", ++poc, temp,
			temp->next, temp->count, temp->word);
	}
}

bool listClear(listDescr *list)
{
	item *temp;
	if (list->first == NULL)
		return false;
	while (list->first)
	{
		temp = list->first;
		list->first = temp->next;  // list->first->next
		free(temp->word);
		free(temp);
	}
	return true;
}
